Package org.springframework.web.bind.support

# Class WebRequestDataBinder

java.lang.Object
org.springframework.validation.DataBinder
org.springframework.web.bind.WebDataBinder
org.springframework.web.bind.support.WebRequestDataBinder

All Implemented Interfaces:
  `org.springframework.beans.PropertyEditorRegistry`, `org.springframework.beans.TypeConverter`

public class WebRequestDataBinder extends WebDataBinder
Special `DataBinder` to perform data binding from web request parameters to JavaBeans, including support for multipart files.

WARNING: Data binding can lead to security issues by exposing parts of the object graph that are not meant to be accessed or modified by external clients. Therefore the design and use of data binding should be considered carefully with regard to security. For more details, please refer to the dedicated sections on data binding for Spring Web MVC and Spring WebFlux in the reference manual.

See the DataBinder/WebDataBinder superclasses for customization options, which include specifying allowed/required fields, and registering custom property editors.

Can also used for manual data binding in custom web controllers or interceptors that build on Spring's `WebRequest` abstraction: for example, in a `WebRequestInterceptor` implementation. Simply instantiate a WebRequestDataBinder for each binding process, and invoke `bind` with the current WebRequest as argument:

     MyBean myBean = new MyBean();
     // apply binder to custom target object
     WebRequestDataBinder binder = new WebRequestDataBinder(myBean);
     // register custom editors, if desired
     binder.registerCustomEditor(...);
     // trigger actual binding of request parameters
     binder.bind(request);
     // optionally evaluate binding errors
     Errors errors = binder.getErrors();
     ...

Since:
  2.5.2
Author:
  Juergen Hoeller, Brian Clozel
See Also:
  - `bind(org.springframework.web.context.request.WebRequest)`
  - `DataBinder.registerCustomEditor(java.lang.Class<?>, java.beans.PropertyEditor)`
  - `DataBinder.setAllowedFields(java.lang.String...)`
  - `DataBinder.setRequiredFields(java.lang.String...)`
  - `WebDataBinder.setFieldMarkerPrefix(java.lang.String)`

## Nested Class Summary

## Nested classes/interfaces inherited from class org.springframework.validation.DataBinder

`org.springframework.validation.DataBinder.NameResolver, org.springframework.validation.DataBinder.ValueResolver`

## Field Summary

### Fields inherited from class org.springframework.web.bind.WebDataBinder

`DEFAULT_FIELD_DEFAULT_PREFIX, DEFAULT_FIELD_MARKER_PREFIX`

### Fields inherited from class org.springframework.validation.DataBinder

`DEFAULT_AUTO_GROW_COLLECTION_LIMIT, DEFAULT_OBJECT_NAME, logger`

## Constructor Summary

Constructors
Constructor
Description
`WebRequestDataBinder(Object target)`
Create a new WebRequestDataBinder instance, with default object name.
`WebRequestDataBinder(Object target, String objectName)`
Create a new WebRequestDataBinder instance.

## Method Summary

Modifier and Type
Method
Description
`void`
`bind(WebRequest request)`
Bind the parameters of the given request to this binder's target, also binding multipart files in case of a multipart request.
`void`
`closeNoCatch()`
Treats errors as fatal.
`void`
`construct(WebRequest request)`
Use a default or single data constructor to create the target by binding request parameters, multipart files, or parts to constructor args.
`protected boolean`
`shouldConstructArgument(org.springframework.core.MethodParameter param)`

### Methods inherited from class org.springframework.web.bind.WebDataBinder

`adaptEmptyArrayIndices, bindMultipart, checkFieldDefaults, checkFieldMarkers, doBind, getEmptyValue, getEmptyValue, getFieldDefaultPrefix, getFieldMarkerPrefix, isBindEmptyMultipartFiles, resolvePrefixValue, setBindEmptyMultipartFiles, setFieldDefaultPrefix, setFieldMarkerPrefix`

### Methods inherited from class org.springframework.validation.DataBinder

`addCustomFormatter, addCustomFormatter, addCustomFormatter, addValidators, applyPropertyValues, bind, checkAllowedFields, checkRequiredFields, close, construct, convertIfNecessary, convertIfNecessary, convertIfNecessary, convertIfNecessary, createBeanPropertyBindingResult, createDirectFieldBindingResult, findCustomEditor, getAllowedFields, getAutoGrowCollectionLimit, getBindingErrorProcessor, getBindingResult, getConversionService, getDisallowedFields, getInternalBindingResult, getNameResolver, getObjectName, getPropertyAccessor, getPropertyEditorRegistry, getRequiredFields, getSimpleTypeConverter, getTarget, getTargetType, getTypeConverter, getValidator, getValidators, getValidatorsToApply, initBeanPropertyAccess, initDirectFieldAccess, isAllowed, isAutoGrowNestedPaths, isDeclarativeBinding, isIgnoreInvalidFields, isIgnoreUnknownFields, registerCustomEditor, registerCustomEditor, replaceValidators, setAllowedFields, setAutoGrowCollectionLimit, setAutoGrowNestedPaths, setBindingErrorProcessor, setConversionService, setDeclarativeBinding, setDisallowedFields, setExcludedValidators, setIgnoreInvalidFields, setIgnoreUnknownFields, setMessageCodesResolver, setNameResolver, setRequiredFields, setTargetType, setValidator, shouldNotBindPropertyValues, validate, validate`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### WebRequestDataBinder

public WebRequestDataBinder(@Nullable Object target)
Create a new WebRequestDataBinder instance, with default object name.

Parameters:
  `target` - the target object to bind onto (or `null` if the binder is just used to convert a plain parameter value)
See Also:
  - `DataBinder.DEFAULT_OBJECT_NAME`

### WebRequestDataBinder

public WebRequestDataBinder(@Nullable Object target, String objectName)
Create a new WebRequestDataBinder instance.

Parameters:
  `target` - the target object to bind onto (or `null` if the binder is just used to convert a plain parameter value)
  `objectName` - the name of the target object

## Method Details

### construct

public void construct(WebRequest request)
Use a default or single data constructor to create the target by binding request parameters, multipart files, or parts to constructor args.

After the call, use `DataBinder.getBindingResult()` to check for bind errors. If there are none, the target is set, and `bind(WebRequest)` can be called for further initialization via setters.

Parameters:
  `request` - the request to bind
Since:
  6.1

### shouldConstructArgument

protected boolean shouldConstructArgument(org.springframework.core.MethodParameter param)

Overrides:
  `shouldConstructArgument` in class `org.springframework.validation.DataBinder`

### bind

public void bind(WebRequest request)
Bind the parameters of the given request to this binder's target, also binding multipart files in case of a multipart request.

This call can create field errors, representing basic binding errors like a required field (code "required"), or type mismatch between value and bean property (code "typeMismatch").

Multipart files are bound via their parameter name, just like normal HTTP parameters: i.e. "uploadedFile" to an "uploadedFile" bean property, invoking a "setUploadedFile" setter method.

The type of the target property for a multipart file can be MultipartFile, byte[], or String. Servlet Part binding is also supported when the request has not been parsed to MultipartRequest via MultipartResolver.

Parameters:
  `request` - the request with parameters to bind (can be multipart)
See Also:
  - `MultipartRequest`
  - `MultipartFile`
  - `Part`
  - `DataBinder.bind(org.springframework.beans.PropertyValues)`

### closeNoCatch

public void closeNoCatch() throws org.springframework.validation.BindException
Treats errors as fatal.

Use this method only if it's an error if the input isn't valid. This might be appropriate if all input is from dropdowns, for example.

Throws:
  `org.springframework.validation.BindException` - if binding errors have been encountered